
--[[
报警器外设控制
]]

module(...,package.seeall)
require"pins"
require"log"


--系统状态
SYS_SIM_ERROR = 1
SYS_NO_NET=2
SYS_NO_SERVER=3
SYS_SERVER_OK=4
SYS_NO_INIT=5
gSysState=0
gkey_flag=0

pmd.ldoset(2,pmd.LDO_VLCD) -- GPIO 0、1、2、3、4
pmd.ldoset(2,pmd.LDO_VMMC) -- GPIO 24、25、26、27、28
pmd.ldoset(2,pmd.LDO_VSIM1)-- GPIO 29、30、31


local gled_net_fun =pins.setup(2,0)
local gled_rdy_fun =pins.setup(3,0)

local function ReloadKeyIntFnc(msg)
    log.info("ReloadKeyIntFnc")
		--上升沿中断
    if msg==cpu.INT_GPIO_POSEDGE then
		--下降沿中断
		gkey_flag =1
    else
		
    end
end

local grelaod_key_fun = pins.setup(5,ReloadKeyIntFnc,pio.PULLUP) --中断

local out_info={
	
	{num=1,gpio=4, 	FUN=nil,level = 0}, --vcc_lcd
	{num=2,gpio=11, FUN=nil,level = 0}

}


local function TestAllLed(onoff)
	local i
	if gled_net_fun then 
		gled_net_fun(onoff)
	end 
	
	if gled_rdy_fun then 
		gled_rdy_fun(onoff)
	end 
	
end  


--设置系统LED指示状态
function PerSetSysState(state)

	gSysState = state
	--log.info("SetSysState",gSysState)
end 

local function LedProTask()
	
	while true do 
		
		if gSysState== SYS_SIM_ERROR then 
			gled_net_fun(1)
			gled_rdy_fun(1)
			sys.wait(5000)
			gled_net_fun(0)
			gled_rdy_fun(0)
			sys.wait(5000)
		elseif gSysState== SYS_NO_NET then 
			gled_rdy_fun(0)
			gled_net_fun(1)
			sys.wait(100)
			gled_net_fun(0)
			sys.wait(100)
		elseif gSysState== SYS_NO_SERVER then
			gled_rdy_fun(0)
			gled_net_fun(1)
			sys.wait(500)
			gled_net_fun(0)
			sys.wait(500)
		elseif gSysState== SYS_SERVER_OK then 
			gled_rdy_fun(1)
			gled_net_fun(1)
			sys.wait(1000)
			gled_net_fun(0)
			sys.wait(1000)
		elseif gSysState== SYS_NO_INIT then 
			gled_net_fun(1)
			gled_rdy_fun(1)
			sys.wait(100)
			gled_net_fun(0)
			gled_rdy_fun(0)
			sys.wait(100)
		else
			sys.wait(1000)
		end 
	end 
end 



function GpioInit()

	local k,v
	--初始化输出
	for k, v in pairs(out_info) do

		log.info("PerInit ","out num=",v.num,"gpio=",v.gpio)
		v.FUN = pins.setup(v.gpio,v.level)
	end
	
end


function OutTest()

	local k,v
	for k, v in pairs(out_info) do
		v.FUN(1)
	end
	
	sys.wait(1000)
	
	for k, v in pairs(out_info) do
		v.FUN(0)
	end
end 


function PerProTask()
	while true
	do
		OutTest()
		sys.wait(1000)
	end
	
end

function PerInit()

	GpioInit()
	TestAllLed(1)
	sys.wait(500)
	TestAllLed(0)
	
	sys.taskInit(PerProTask)
	sys.taskInit(LedProTask)
end 



